<?php

class ANIMATE_BOL_Service {

    const LANG_KEY = 'animate';
    const CONFIG_KEY = 'animate';

    const SHOW_SETTING = 'show';
    const ERROR_SETTING = 'error';
    const CLOSE_SETTING = 'close';

    use ANIMATE_CLASS_TraitSingleton;

    protected function init() { }

    public function getAvailableAnimateEffects() {
        return [
            'bounce', 'flash', 'pulse', 'rubberBand', 'shake', 'headShake', 'swing', 'tada', 'wobble', 'jello',
            'bounceIn', 'bounceInDown', 'bounceInLeft', 'bounceInRight', 'bounceInUp', 'bounceOut', 'bounceOutDown',
            'bounceOutLeft', 'bounceOutRight', 'bounceOutUp', 'fadeIn', 'fadeInDown', 'fadeInDownBig', 'fadeInLeft',
            'fadeInLeftBig', 'fadeInRight', 'fadeInRightBig', 'fadeInUp', 'fadeInUpBig', 'fadeOut', 'fadeOutDown',
            'fadeOutDownBig', 'fadeOutLeft', 'fadeOutLeftBig', 'fadeOutRight', 'fadeOutRightBig', 'fadeOutUp',
            'fadeOutUpBig', 'flip', 'flipInX', 'flipInY', 'flipOutX', 'flipOutY', 'lightSpeedIn', 'lightSpeedOut',
            'rotateIn', 'rotateInDownLeft', 'rotateInDownRight', 'rotateInUpLeft', 'rotateInUpRight', 'rotateOut',
            'rotateOutDownLeft', 'rotateOutDownRight', 'rotateOutUpLeft', 'rotateOutUpRight', 'hinge', 'rollIn',
            'rollOut', 'zoomIn', 'zoomInDown', 'zoomInLeft', 'zoomInRight', 'zoomInUp', 'zoomOut', 'zoomOutDown',
            'zoomOutLeft', 'zoomOutRight', 'zoomOutUp', 'slideInDown', 'slideInLeft', 'slideInRight', 'slideInUp',
            'slideOutDown', 'slideOutLeft', 'slideOutRight', 'slideOutUp'
        ];
    }

    public function saveSettings(array $settings) {
        $availableSetting = $this->getAvailableAnimateEffects();
        $config = OW::getConfig();

        foreach ([self::SHOW_SETTING, self::ERROR_SETTING, self::CLOSE_SETTING] as $setting) {
            if (!isset($settings[$setting]) || array_search($settings[$setting], $availableSetting, true) === false) {
                continue;
            }

            $config->saveConfig(self::CONFIG_KEY, $setting, $settings[$setting]);
        }
    }

}
