<?php

class ANIMATE_CLASS_EventHandler {

    use ANIMATE_CLASS_TraitSingleton;

    protected function init() { }

    public function bindEvent() {
        $eventManager = OW::getEventManager();

        $eventManager->bind(OW_EventManager::ON_FINALIZE, function () {
            $settings = OW::getConfig()->getValues(ANIMATE_BOL_Service::CONFIG_KEY);
            $document = OW::getDocument();

            $document->addScriptDeclarationBeforeIncludes(
                UTIL_JsGenerator::composeJsString(
                    ';window.ANIMATE_SETTINGS = Object.freeze({$settings});',
                    ['settings' => $settings]
                )
            );

            $plugin = OW::getPluginManager()->getPlugin('animate');

            $document->addStyleSheet($plugin->getStaticCssUrl() . 'animate.min.css');
            $document->addScript($plugin->getStaticJsUrl() . 'animate.js');
        });
    }

}
