<?php

class ANIMATE_CLASS_SettingsForm extends Form {

    const FROM_NAME = 'animate-settings-form';
    const SHOW_SETTING = ANIMATE_BOL_Service::SHOW_SETTING;
    const ERROR_SETTING = ANIMATE_BOL_Service::ERROR_SETTING;
    const CLOSE_SETTING = ANIMATE_BOL_Service::CLOSE_SETTING;
    const SUBMIT = 'submit';

    public function __construct() {
        parent::__construct(self::FROM_NAME);

        $langKey = ANIMATE_BOL_Service::LANG_KEY;
        $language = OW::getLanguage();
        $configs = OW::getConfig()->getValues(ANIMATE_BOL_Service::CONFIG_KEY);
        $service = ANIMATE_BOL_Service::getInstance();
        $options = array_combine(
            $service->getAvailableAnimateEffects(),
            $service->getAvailableAnimateEffects()
        );

        $show = new Selectbox(self::SHOW_SETTING);
        $show->setLabel($language->text($langKey, 'show_label'));
        $show->setValue($configs[self::SHOW_SETTING]);
        $show->setOptions($options);
        $this->addElement($show);

        $error = new Selectbox(self::ERROR_SETTING);
        $error->setLabel($language->text($langKey, 'error_label'));
        $error->setValue($configs[self::ERROR_SETTING]);
        $error->setOptions($options);
        $this->addElement($error);

        $close = new Selectbox(self::CLOSE_SETTING);
        $close->setLabel($language->text($langKey, 'close_label'));
        $close->setValue($configs[self::CLOSE_SETTING]);
        $close->setOptions($options);
        $this->addElement($close);

        $submit = new Submit(self::SUBMIT);
        $this->addElement($submit);
    }

}
